#region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_UseX64=n
#AutoIt3Wrapper_Res_Description=WinSendKeys
#AutoIt3Wrapper_Res_Fileversion=3.0.4.0
#AutoIt3Wrapper_Res_LegalCopyright=(c) 2011 Ath
#AutoIt3Wrapper_Res_Language=1033
#endregion ;**** Directives created by AutoIt3Wrapper_GUI ****
$appVersion = "3.0.4"
; WinSendKeys 3.0.4
; By Ath, after a request by Split_e at www.donationcoder.com/forum/index.php?topic=25389.0
; History:
; 2011-04-22, version 3.0.4.0
; ! Bugfix if -? was given for parameter. Is now handled properly.
; * Added version & info resource to compiled exe
; * Changed by adding #regions to allow code-folding for a little easier maintainability
; 2011-03-13, version 3.0.3
; * Improvement: A numeric WindowName is now treated as a WindowHandle (HWnd), as requested by mouser
; 2011-03-12, version 3.0.2
; ! BugFix in detecting an active application/window
; + Added application version to helpmessage
; * Minor cleanup
; * Adapted the helptext somewhat
; ! Revision history reverted, now has latest on top
; 2011-02-11, version 3.0.1
; + Added -xd delay option to wait after running the -x executable_filepath. It already has the delay of -t (100 msec), and this is added when specified. Experiment with the required delay (milliseconds).
;   as additionally requested by kikon in this thread: http://www.donationcoder.com/forum/index.php?topic=25553
; + This delay can be preset in the optional inifile, (see version 2.5 changelog)
;   Variable:
;   exedelay=0
; ! Updated helpmessage, fixed some readme typos
; 2011-02-09, version 3.0
; + Added -x executable_filepath option to start if WindowName is not found or executable filename is not found running
;   as additionally requested by kikon in this thread: http://www.donationcoder.com/forum/index.php?topic=25553
; + Added -xp executable_parameters option to specify parameters to executable_filepath
; 2011-02-07, version 2.6
; + Added -c option to read keystrokes from the clipboard, as requested by mouser & kikon in this thread: http://www.donationcoder.com/forum/index.php?topic=25553
; + Added -cn option, like -c, but does not send an {ENTER} after each line, can be added after -c -r -cc to disable the {Enter} being sent
; + Added -cc option, like -c but embeds the clipboard into the KeyStrokes commandline sequence using #$ prefix, see readme for details
; 2011-01-30, version 2.5
; ! Avoid ever overwriting the script with debug-log-file (if not .au3 or .exe extension, add .log to scriptname)
; + Added reading settings from optional .ini file:
;   Get parameters from .ini file with the same name as this script/exe, only if the file exists, create file manually!
;   Sectionname: [Settings]
;   Variables:
;   delay=100 : delay between keystrokes/mousestrokes sent to the application
;   mousestrokes=0 : Enable mousestrokes by setting this to 1
;   mousespeed=0 : Speedfactor for mouse move, value between 0 and 100, 0 = immediate, 1 = fast, 100 = slow
; - Documented and optimized script functions
; 2011-01-29, version 2.5-beta
; + Added -f strokesfile option to read keystrokes and mousestrokes from named file,
;            commandline strokes are handled first
; - Minor adjustments
; 2011-01-28, version 2.0,
; * Changed WinTitleMatchMode to be case-insensitive
; ! Fixed MouseClick mode
; + Allow Activate-Only by giving no keystrokes
; - Window not found message shows only in debug mode
; - Updated helpmessage
; 2011-01-27, version 2.0-beta,
; + Added mouse-modes, postfix with ## for ControlClick, #% for MouseClick
; + Added more logging and messages
; 2011-01-25
; ! upx compression disabled
; + Debug mode writes to .log file
; - Formatted helpmessage a little better
; 2011-01-24
; + Initial release, send keystrokes to a named window
;--------------------------------
; options:
; -t timeout
; -w windowname
;    naming according to these rules: http://www.autoitscript.com/autoit3/docs/intro/windowsadvanced.htm
; -d : Debug mode
; -m : Enable mouse-mode, cursor speed 0 = immediate
; -mm speed : Enable mouse-mode, moving cursor with speed (1..100)
; -f strokesfile ; Read KeyStrokes/MouseStrokes from this file. Any commandline provided strokes are handled first
; -c : Enable clipboard-mode, read KeyStrokes/MouseStrokes from the Windows clipboard
; -x executable_filepath : Enable mode to start that exe if WindowName not found (or not provided) and executable filename not found running
; -xp executable_parameters : Parameters to pass to executablefilepath specified using -x option, enclose in quotes when spaces are needed
; -xd delay : Number of milliseconds to wait after starting executable_filepath before execution continues
; Keystrokes: http://www.autoitscript.com/autoit3/docs/appendix/SendKeys.htm
; Mouse-mode uses ControlClick or MouseClick, depending on parameters, see:
;  http://www.autoitscript.com/autoit3/docs/functions/ControlClick.htm
;  http://www.autoitscript.com/autoit3/docs/functions/MouseClick.htm

#region ; Public vars
$dela = 100 ; msec delay between keystrokes sent
$win = "" ; Name of Window to activate
$dbg = 0 ; Debug mode
$dbgfile = "" ; Write logging to this file
$canmouse = 0 ; Enable mouse actions
$mspeed = 0 ; Mouse-speed
$fmode = 0 ; File-mode
$fname = "" ; File to read strokes from
$cmode = 0 ; Clipboard-mode
$cemode = 1 ; Clipboardmode with Enter
Dim $carr[1] = [0] ; Initialize clipboard stuff
$cline = 0
$xfile = "" ; Executablefilepath
$xpara = "" ; Exectutable parameters
$xdela = 0 ; Execute Delay in msec
$help = 0 ; Display help?
#endregion

#region ; Main
;-----------------------
; main()
;-----------------------
If $CmdLine[0] < 1 Then
	ShowHelp()
Else
	readIniFile()
	$p = 1
	$n = 1
	While $n <= $CmdLine[0]
		If ($p = $n) And (StringLeft($CmdLine[$n], 1) = "-") Then
			If (StringLower($CmdLine[$n]) = "-t") And ($n < $CmdLine[0]) Then
				$n = $n + 1
				$dela = $CmdLine[$n]
				$p = $n + 1
				If $dbg Then writeLogLine("Keystroke send delay (-t): " & $dela)
			EndIf
			If (StringLower($CmdLine[$n])) = "-w" And ($n < $CmdLine[0]) Then
				$n = $n + 1
				$win = $CmdLine[$n]
				$p = $n + 1
				If $dbg Then writeLogLine("Window name (-w): " & $win)
			EndIf
			If StringLower($CmdLine[$n]) = "-d" Then
				$dbg = 1
				$p = $n + 1
				$dbgfile = StringReplace(@ScriptName, ".au3", ".log")
				If $dbgfile = @ScriptName Then
					$dbgfile = StringReplace(@ScriptName, ".exe", ".log")
					If $dbgfile = @ScriptName Then $dbgfile = @ScriptName & ".log" ; Extra safety-measure
				EndIf
				If $dbg Then writeLogLine("Debug logging enabled")
			EndIf
			If StringLower($CmdLine[$n]) = "-m" Then
				$canmouse = 1
				$p = $n + 1
				If $dbg Then writeLogLine("Mousemode enabled")
			EndIf
			If (StringLower($CmdLine[$n])) = "-mm" And ($n < $CmdLine[0]) Then
				$canmouse = 1
				$n = $n + 1
				$mspeed = $CmdLine[$n]
				If $mspeed < 0 Or $mspeed > 100 Then $mspeed = 0
				$p = $n + 1
				If $dbg Then writeLogLine("Mousemode enabled, speed: " & $mspeed)
			EndIf
			If (StringLower($CmdLine[$n]) = "-f") And ($n < $CmdLine[0]) Then
				$n = $n + 1
				$fmode = 1
				$fname = $CmdLine[$n]
				$p = $n + 1
				If $dbg Then writeLogLine("Filemode, reading from file: " & $fname)
			EndIf
			If StringLower($CmdLine[$n]) = "-c" Then
				$cmode = 1
				$p = $n + 1
				If $dbg Then writeLogLine("Clipboardmode enabled")
			EndIf
			If StringLower($CmdLine[$n]) = "-cc" Then
				$cmode = 2
				$p = $n + 1
				If $dbg Then writeLogLine("Clipboard-command-mode #$ enabled")
			EndIf
			If StringLower($CmdLine[$n]) = "-cn" Then
				If Not $cmode Then $cmode = 1
				$cemode = 0
				$p = $n + 1
				If $dbg Then writeLogLine("Clipboardmode without Enter enabled")
			EndIf
			If (StringLower($CmdLine[$n]) = "-x") And ($n < $CmdLine[0]) Then
				$n = $n + 1
				$xfile = $CmdLine[$n]
				$p = $n + 1
				If $dbg Then writeLogLine("Executable Filepath specified: " & $xfile)
			EndIf
			If (StringLower($CmdLine[$n]) = "-xp") And ($n < $CmdLine[0]) Then
				$n = $n + 1
				$xpara = $CmdLine[$n]
				$p = $n + 1
				If $dbg Then writeLogLine("Executable Parameters specified: " & $xpara)
			EndIf
			If (StringLower($CmdLine[$n]) = "-xd") And ($n < $CmdLine[0]) Then
				$n = $n + 1
				$xdela = $CmdLine[$n]
				$p = $n + 1
				If $dbg Then writeLogLine("Executable Delay specified: " & $xdela)
			EndIf
			If $CmdLine[$n] = "-?" Then
				$p = $n + 1
				$help = 1
				If $dbg Then writeLogLine("Helpmode enabled")
			EndIf
		EndIf
		$n = $n + 1
	WEnd
	If $win = "" And $p <= $CmdLine[0] Then
		$win = $CmdLine[$p]
		$p = $p + 1
	EndIf
	MsgBox(0,"Debug","Help : " & $help & " cmd: " & $CmdLine[0])
	If ($win = "" And $xfile = "") Or $help > 0 Then
		ShowHelp()
	Else
		$w = 0
		$xname = ""
		; Split executablefilepath to destill the filename
		If $xfile <> "" Then
			$xd = ""
			$xparts = _PathSplit($xfile, $xd, $xd, $xd, $xd)
			$xname = $xparts[3] & $xparts[4]
			If $dbg Then writeLogLine("exename: " & $xname)
			If $win = "" Then
				$procs = ProcessList()
				$n = 1
				While $n < $procs[0][0]
					If StringCompare($xfile, $procs[$n][0]) = 0 Then
						$win = PidToWindowName($procs[$n][1], $w)
						$n = $procs[0][0]
					EndIf
					$n += 1
				WEnd
				If $win = "" Then $win = $xname
				$xname = ""
			EndIf
		EndIf
		If $dbg Then writeLogLine("Window: " & $win)
		AutoItSetOption("WinTitleMatchMode", -2) ; Not casesensitive
		; Try to find the named window
		If StringIsDigit($win) Then $win = HWnd($win) ; Convert to Windows Handle if numeric
		$w = WinActivate($win, "")
		If $w = 0 And $xname <> "" Then
			$win = $xname
			$xname = ""
			If StringIsDigit($win) Then $win = HWnd($win) ; Convert to Windows Handle if numeric
			$w = WinActivate($win, "")
		EndIf
		If $dbg Then writeLogLine("Windowhandle: " & $w)
		; Optionally start the named exe if window not found
		If $w = 0 And $xfile <> "" Then
			If $dbg Then writeLogLine("Running executable: " & $xfile & " " & $xpara)
			$p = Run($xfile & " " & $xpara, "")
			Sleep($dela) ; A little delay after loading
			If $xdela > 0 Then Sleep($xdela) ; Optional some more delay
			If $dbg Then writeLogLine("Running executable PID: " & $p)
			If $p <> 0 Then
				$win = PidToWindowName($p, $w)
			EndIf
		EndIf
		; Still not found?
		If $w = 0 Then
			If $dbg Then writeLogLine("Window '" & $win & "' not found.")
			If $dbg Then MsgBox(32, "WinSendKeys Debug", "Window '" & $win & "' not found.")
		Else
			If $dbg Then writeLogLine("Window '" & $win & "' activated.")
			If $cmode Then ; Optionally handle Clipboard, parse contents
				$clp = ClipGet()
				$cerror = @error
				If $cerror > 0 Then
					If $dbg Then writeLogLine("Error: " & $cerror & " reading Clipboard, content: '" & $clp & "'.")
				Else
					$carr = StringSplit($clp, @CRLF, 1) ; Assume text with possible newlines
					If $dbg Then writeLogLine("Clipboard: parsed: '" & $clp & "' no. of lines: " & $carr[0])
				EndIf
			EndIf
			; Start processing data
			SendKeepActive($w)
			; First: Handle commandline strokes
			For $n = $p To $CmdLine[0]
				handleCommand($CmdLine[$n])
				If $n < $CmdLine[0] Then Sleep($dela) ; Don't wait after the last stroke
			Next
			If $fmode Then ; Optionally handle strokefile
				If FileExists($fname) Then
					Local $fhandle = FileOpen($fname, 0)
					If $fhandle = -1 Then
						If $dbg Then writeLogLine("Error: Cannot open file '" & $fname & "'")
						MsgBox(32, "WinSendKeys Debug", "Error: Cannot open file '" & $fname & "'")
					Else
						$err = 0 ; Initialize
						While $err = 0
							$cmd = FileReadLine($fhandle)
							$err = @error ; get correct status
							If StringLeft($cmd, 1) <> ";" And Not StringIsSpace($cmd) Then ; Only non-comment and non-empty lines
								handleCommand($cmd)
								If $err = 0 Then Sleep($dela) ; Don't wait after the last stroke
							EndIf
						WEnd
						FileClose($fhandle)
					EndIf
				Else
					If $dbg Then writeLogLine("Error: File '" & $fname & "' not found.")
					MsgBox(32, "WinSendKeys Debug", "Error: File '" & $fname & "' not found.")
				EndIf
			EndIf
			If $cmode = 1 Then ; Optionally handle Clipboard
				If $dbg Then writeLogLine("Clipboard: send all content, no. of lines: " & $carr[0])
				For $i = 1 To $carr[0]
					If $carr[$i] <> "" Or $i < $carr[0] Then
						handleCommand($carr[$i])
						If $cemode Then handleCommand("{ENTER}")
						If $i < $carr[0] Then Sleep($dela) ; Don't wait after the last stroke
					EndIf
				Next
			EndIf
		EndIf
	EndIf
EndIf
#endregion

;-----------------------
; handleCommand()
; Parses a single KeyStroke or MouseStroke command and executes it when correct, also handles $cmode 2 (-cc option)
;-----------------------
Func handleCommand($cmd)
	Local $handled = 0
	Local $mousepar
	Local $res = 0
	If $canmouse And (StringLeft($cmd, 2) = "##" Or StringLeft($cmd, 2) = "#%") Then
		If $dbg Then writeLogLine("MouseMode: " & $cmd)
		$mousepar = StringSplit(StringMid($cmd, 3), ",")
		; ControlClick handling takes 3 to 7 parameters
		If StringLeft($cmd, 2) = "##" And $mousepar[0] > 2 Then
			AutoItSetOption("MouseCoordMode", 2) ; Control-relative mode
			If $mousepar[0] < 4 Then
				ReDim $mousepar[5]
				$mousepar[0] = 4
			EndIf
			If $mousepar[1] = "" Or $mousepar[1] = '""' Then $mousepar[1] = $win
			If StringIsDigit($mousepar[3]) Then $mousepar[3] = "[ID:" & $mousepar[3] & "]"
			If $mousepar[4] = "" Or $mousepar[4] = '""' Then $mousepar[4] = "primary"
			If $mousepar[0] > 4 And $mousepar[5] = 0 Then $mousepar[5] = 1
			If $dbg Then
				$msg = "ControlClick: " & $mousepar[0] & " : "
				For $i = 1 To $mousepar[0]
					$msg = $msg & $mousepar[$i]
					If $i < $mousepar[0] Then $msg = $msg & ","
				Next
				writeLogLine($msg)
			EndIf
			$res = -1
			$ctrlpos = ControlGetPos($mousepar[1], $mousepar[2], $mousepar[3])
			Switch $mousepar[0]
				Case 4
					If @error = 0 Then MouseMove($ctrlpos[2] / 2, $ctrlpos[3] / 2, $mspeed)
					$res = ControlClick($mousepar[1], $mousepar[2], $mousepar[3], $mousepar[4])
				Case 5
					If @error = 0 Then MouseMove($ctrlpos[2] / 2, $ctrlpos[3] / 2, $mspeed)
					$res = ControlClick($mousepar[1], $mousepar[2], $mousepar[3], $mousepar[4], $mousepar[5])
				Case 6
					If @error = 0 Then MouseMove($mousepar[6], $ctrlpos[3] / 2, $mspeed)
					$res = ControlClick($mousepar[1], $mousepar[2], $mousepar[3], $mousepar[4], $mousepar[5], $mousepar[6])
				Case 7
					MouseMove($mousepar[6], $mousepar[7], $mspeed)
					$res = ControlClick($mousepar[1], $mousepar[2], $mousepar[3], $mousepar[4], $mousepar[5], $mousepar[6], $mousepar[7])
			EndSwitch
			If $dbg Then writeLogLine("ControlClick done, result: " & $res)
			$handled = 1
		EndIf
		; MouseClick handling, takes 3 to 5 parameters
		If StringLeft($cmd, 2) = "#%" And $mousepar[0] > 2 Then
			AutoItSetOption("MouseCoordMode", 0) ; Window-relative mode
			If $mousepar[1] = "" Or $mousepar[1] = '""' Then $mousepar[1] = "primary"
			If $mousepar[0] >= 5 And $mousepar[5] = "" Then $mousepar[5] = $mspeed
			If $dbg Then
				$msg = "MouseClick: " & $mousepar[0] & " : "
				For $i = 1 To $mousepar[0]
					$msg = $msg & $mousepar[$i]
					If $i < $mousepar[0] Then $msg = $msg & ","
				Next
				writeLogLine($msg)
			EndIf
			$res = -1
			Switch $mousepar[0]
				Case 3
					$res = MouseClick($mousepar[1], $mousepar[2], $mousepar[3], 1, $mspeed)
				Case 4
					$res = MouseClick($mousepar[1], $mousepar[2], $mousepar[3], $mousepar[4], $mspeed)
				Case 5
					$res = MouseClick($mousepar[1], $mousepar[2], $mousepar[3], $mousepar[4], $mousepar[5])
			EndSwitch
			If $dbg Then writeLogLine("MouseClick done, result: " & $res)
			$handled = 1
		EndIf
	EndIf
	; Clipboard mode -cc handling
	If $cmode = 2 And StringLeft($cmd, 2) = "#$" And $cline <= $carr[0] And $carr[0] > 0 Then
		$clpc = StringMid($cmd, 3)
		If $dbg Then writeLogLine("Clipboard command: " & $clpc & " cline: " & $cline)
		If $clpc = "*" Then ; Send all
			For $cline = 1 To $carr[0]
				$cmd = $carr[$cline]
				If $cemode Then $cmd = $cmd & "{ENTER}"
				If $dbg Then writeLogLine("Send clip: " & $cmd)
				Send($cmd)
				If $cline < $carr[0] Then Sleep($dela)
			Next
		Else
			If $clpc = 0 Then ; Auto-increment, next line, stop at end
				$cline += 1
			Else
				If $clpc <= $carr[0] Then ; Select a clipboard line
					$cline = $clpc
				Else
					$cline = -1
				EndIf
			EndIf
			If $cline > 0 And $cline <= $carr[0] Then
				$cmd = $carr[$cline]
				If $cemode Then $cmd = $cmd & "{ENTER}"
				If $dbg Then writeLogLine("Send a clip: " & $cmd)
				Send($cmd)
			Else
				If $cline = -1 Then $cline = 0 ; Reset after error
			EndIf
		EndIf
		$handled = 1
	EndIf
	; If not handled yet, send as keystrokes
	If Not $handled Then
		If $dbg Then writeLogLine("Send: " & $cmd)
		Send($cmd)
	EndIf

EndFunc   ;==>handleCommand

;--------------------------
; PidToWindowName($pid, ByRef $winhandle)
; Find a WindowName and WindowHandle (hWND) by it's PID
;--------------------------
Func PidToWindowName($pid, ByRef $winhandle)
	Local $procs = WinList()
	Local $n = 1
	Local $winname = ""
	$winhandle = 0
	While $n <= $procs[0][0]
		If $procs[$n][0] <> "" And WinGetProcess($procs[$n][0]) = $pid Then
			$winname = $procs[$n][0]
			$winhandle = $procs[$n][1]
			If $dbg Then writeLogLine("Title for PID: " & WinGetProcess($procs[$n][0]) & " hWND: " & $winhandle & " / " & $winname)
			$n = $procs[0][0] ; Exit loop if found
		EndIf
		$n += 1
	WEnd
	Return $winname
EndFunc   ;==>PidToWindowName

;--------------------------
; showHelp()
; Display a messagebox with some help text
;--------------------------
Func ShowHelp()
	MsgBox(0, "WinSendKeys " & $appVersion & " : Send keystrokes and/or mouse-clicks to a window", _
			"WinSendKeys [-t delay] [-d] [-m|-mm speed] [-f strokefile] [-c] [-cc] [-cn]" & @CRLF _
			 & @TAB & "[-x executable_filepath] [-xp executable_parameters] [-xd delay] " & @CRLF _
			 & @TAB & "[-?] [-w] <WindowName> [<KeyStrokes/MouseStrokes>] [...]" & @CRLF _
			 & "Options:" & @CRLF _
			 & "-t delay = msec value, default 100" & @CRLF _
			 & "-d = Debug mode, writes extra information to WinSendKeys.log" & @CRLF _
			 & "-m = mouse-mode, speed = 0 = immediate" & @CRLF _
			 & "-mm  speed = mouse-mode, move mouse with speed 0..100" & @CRLF _
			 & "-f strokefile = read strokes from strokefile, commandline strokes go first!" & @CRLF _
			 & "-c = ClipStrokes mode, send strokes line by line from clipboard + {ENTER}" & @CRLF _
			 & "-cc = ClipStroke 2 mode, commandline ClipStroke #$[*|<n>] + {ENTER}" & @CRLF _
			 & "-cn = Disable {ENTER} after -c or -cc ClipStrokes" & @CRLF _
			 & "-x executable_filepath = Run this if WindowName not found" & @CRLF _
			 & "-xp executable_parameters = Parameters to pass to executable_filepath" & @CRLF _
			 & "-xd delay = Wait for delay msec before passing strokes after running -x" & @CRLF _
			 & "-? = Display this help message" & @CRLF _
			 & "-w <WindowName> = name value as defined here:" & @CRLF _
			 & @TAB & "www.autoitscript.com/autoit3/docs/intro/windowsadvanced.htm" & @CRLF _
			 & "<KeyStrokes> = Keystroke values as defined here:" & @CRLF _
			 & @TAB & "www.autoitscript.com/autoit3/docs/appendix/SendKeys.htm" & @CRLF _
			 & "<MouseStrokes> = comma-separated list prefixed with:" & @CRLF _
			 & @TAB & "## for ControlClick params, doc:" & @CRLF _
			 & @TAB & "www.autoitscript.com/autoit3/docs/functions/ControlClick.htm" & @CRLF _
			 & @TAB & "#% for MouseClick params, doc:" & @CRLF _
			 & @TAB & "www.autoitscript.com/autoit3/docs/functions/MouseClick.htm" & @CRLF _
			)
EndFunc   ;==>ShowHelp

;--------------------------
; writeLogLine($message)
; Write $message to the logfile, prepended with date/time
;--------------------------
Func writeLogLine($message)
	; Write a line to the logfile, with a prefix of "yyyy-MM-dd hh:mm:ss.msec, ", as the generic _FileWriteLog function gave errors
	Local $openLogFile = FileOpen($dbgfile, 1)
	If $openLogFile > -1 Then
		FileWriteLine($openLogFile, @YEAR & "-" & @MON & "-" & @MDAY & " " & @HOUR & ":" & @MIN & ":" & @SEC & "." & StringFormat("%03d", @MSEC) & ", " & $message)
		FileClose($openLogFile)
	EndIf
EndFunc   ;==>writeLogLine

;--------------------------
; readIniFile()
; Get parameters from .ini file with the same name as this script/exe, only if the file exists!
; Sectionname: [Settings]
; Variables:
; delay : delay between keystrokes/mousestrokes sent to the application, default = 100
; mousestrokes : Enable mousestrokes by setting this to 1, default = 0 = off
; mousespeed : Speedfactor for mouse move, value between 0 (default) and 100, 0 = immediate, 1 = fast, 100 = slow
;--------------------------
Func readIniFile()
	Local $ini = StringReplace(@ScriptName, ".au3", ".ini")
	If $ini = @ScriptName Then
		$ini = StringReplace(@ScriptName, ".exe", ".ini")
		If $ini = @ScriptName Then $ini = "" ; Safety first
	EndIf
	If $ini <> "" And FileExists($ini) Then
		; $dela = 100 ; msec delay between keystrokes sent
		$dela = IniRead($ini, "Settings", "delay", $dela)
		If $dbg And $dela <> 100 Then writeLogLine("Keystroke send delay from ini: " & $dela & @CRLF)
		; $canmouse = 0 ; Enable mouse actions
		$canmouse = Int(IniRead($ini, "Settings", "mousestrokes", $canmouse))
		; $mspeed = 0 ; Mouse-speed
		$mspeed = IniRead($ini, "Settings", "mousespeed", $mspeed)
		; $xdela = 0 ; Execute Delay in msec
		$xdela = IniRead($ini, "Settings", "exedelay", $xdela)
		If $xdela > 0 And $dbg Then writeLogLine("Executable Delay from ini: " & $xdela)
		If $mspeed < 0 Or $mspeed > 100 Then $mspeed = 0
		If $canmouse And $dbg Then writeLogLine("Mousemode enabled from ini, speed: " & $mspeed & @CRLF)
	EndIf
EndFunc   ;==>readIniFile

; End of script
#include <File.au3>
